﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace _135646
{
    public class DataItem:INotifyPropertyChanged
    {
        string description;
        public string Description
        {
            get { return description; }
            set
            {
                description = value;
                NotifyProperty("Description");
            }
        }

        string format;
        public string Format
        {
            get { return format; }
            set
            {
                format = value;
                NotifyProperty("Format");
            }
        }

        BindingList<RowType<License>> licenses;
        public BindingList<RowType<License>> Licenses
        {
            get { return licenses; }
            private  set { licenses = value;
            NotifyProperty("Licenses");
            }
        }

        BindingList<RowType<Summary>> summaries;
        public BindingList<RowType<Summary>> Summaries
        {
            get { return summaries; }
            private set
            {
                summaries = value;
                NotifyProperty("Summaries");
            }
        }

        public DataItem()
        {
            licenses = new BindingList<RowType<License>>();
            licenses.Add(new RowType<License>());

            summaries = new BindingList<RowType<Summary>>();
            summaries.Add(new RowType<Summary>());
        }

        #region INotifyPropertyChanged Members
        private void NotifyProperty(string prop)
        {
            if (PropertyChanged != null)
                PropertyChanged.Invoke(this, new PropertyChangedEventArgs(prop));
        }
        public event PropertyChangedEventHandler PropertyChanged;

        #endregion
    }

    public class RowType<T> : INotifyPropertyChanged
    {
        string name;

        public string Name
        {
            get { return name; }
            private  set { name = value;
            NotifyProperty("Name");
            }
        }

        BindingList<T> items;

        public BindingList<T> Items
        {
            get { return items; }
            private set { items = value;
            NotifyProperty("Items");
            }
        }

        public RowType()
        {
            items = new BindingList<T>();
            items.ListChanged += items_ListChanged;
            items.AddingNew += items_AddingNew;
            setName();
        }

        void items_AddingNew(object sender, AddingNewEventArgs e)
        {
            setName();
        }

        void items_ListChanged(object sender, ListChangedEventArgs e)
        {
            setName();
        }

        private void setName()
        {
            this.Name =  string.Format("{0}:{1} ({2} items)", "RowType", typeof(T).Name, items.Count);
        }

        #region INotifyPropertyChanged Members
        private void NotifyProperty(string prop)
        {
            if (PropertyChanged != null)
                PropertyChanged.Invoke(this, new PropertyChangedEventArgs(prop));
        }
        public event PropertyChangedEventHandler PropertyChanged;

        #endregion
    }

    public class License : INotifyPropertyChanged
    {
        string description;

        public string Description
        {
            get { return description; }
            set { description = value;
            NotifyProperty("Description");
            }
        }

        DateTime experationDate;

        public DateTime ExperationDate
        {
            get { return experationDate; }
            set { experationDate = value;
            NotifyProperty("ExperationDate");
            }
        }


        #region INotifyPropertyChanged Members
        private void NotifyProperty(string prop)
        {
            if (PropertyChanged != null)
                PropertyChanged.Invoke(this, new PropertyChangedEventArgs(prop));
        }
        public event PropertyChangedEventHandler PropertyChanged;

        #endregion
    }

    public class Summary : INotifyPropertyChanged
    {
        string description;

        public string Description
        {
            get { return description; }
            set
            {
                description = value;
                NotifyProperty("Description");
            }
        }

        DateTime experationDate;

        public DateTime ExperationDate
        {
            get { return experationDate; }
            set
            {
                experationDate = value;
                NotifyProperty("ExperationDate");
            }
        }


        #region INotifyPropertyChanged Members
        private void NotifyProperty(string prop)
        {
            if (PropertyChanged != null)
                PropertyChanged.Invoke(this, new PropertyChangedEventArgs(prop));
        }
        public event PropertyChangedEventHandler PropertyChanged;

        #endregion
    }
}
