﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace _135646
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {


            DataSet ds = new DataSet();
            DataTable parent = ds.Tables.Add("parent");
            parent.Columns.Add("series_cde", typeof(int)).AutoIncrement = true;
            parent.Columns.Add("Column 1", typeof(string)).DefaultValue = "Column 1";
            parent.Columns.Add("Column 2", typeof(string)).DefaultValue = "Column 2";

            DataTable level1 = ds.Tables.Add("Table1");
            level1.Columns.Add("series_cde", typeof(int));
            level1.Columns.Add("Summary Value", typeof(string));

            ds.Relations.Add("Table1", parent.Columns["series_cde"], level1.Columns["series_cde"]);

            geneareTable("License", ds.Tables["Table1"], "series_cde");
            geneareTable("Summary", ds.Tables["Table1"], "series_cde");
            geneareTable("Version", ds.Tables["Table1"], "series_cde");
            geneareTable("Episode", ds.Tables["Table1"], "series_cde");

            DataTable level2 = ds.Tables.Add("Table2");
            level2.Columns.Add("series_cde", typeof(int));
            level2.Columns.Add("episode_Cde", typeof(int));
    
            level2.Columns.Add("Summary Value", typeof(string));

            DataColumn[] parentColumns = new DataColumn[] { ds.Tables["Episode"].Columns["series_cde"], ds.Tables["Episode"].Columns["episode_Cde"] };
            DataColumn[] childColumns = new DataColumn[] {
	level2.Columns["series_cde"],
	level2.Columns["episode_Cde"]
};

            ds.Relations.Add("Table2", parentColumns, childColumns);

            geneareEpsTable("EpsLicense", ds.Tables["Table2"], "episode_Cde");
            geneareEpsTable("EpsSummary", ds.Tables["Table2"], "episode_Cde");
            geneareEpsTable("EpsVersion", ds.Tables["Table2"], "episode_Cde");

            Random rnd = new Random();

            for (int i = 0; i < 10; i++)
            {
                DataRow parentRow = parent.Rows.Add();
                DataRow row = level1.Rows.Add(parentRow[0]);
                foreach (DataRelation rel in level1.ChildRelations)
                {
                    Thread.Sleep(2);
                    DataTable dt = rel.ChildTable;
                    int childRows = rnd.Next(1, 100);
                    for (int j = 0; j < childRows; j++)
                    {
                        dt.Rows.Add(row["series_cde"]);
                    }
                }               
            }
            for (int i = 0; i < ds.Tables["Episode"].Rows.Count - 1; i++)
            {
                DataRow parentRow = ds.Tables["Episode"].Rows[i];
                level2.Rows.Add(parentRow[0], parentRow[1]);
            }
            level2.AcceptChanges();
            ds.EnforceConstraints = false;

          for (int i = 0; i< level2.Rows.Count - 1; i++)
          {
              DataRow parentRow = level2.Rows[i];
                
                foreach (DataRelation rel in level2.ChildRelations)
                {
                    Thread.Sleep(2);
                    DataTable dt = rel.ChildTable;
                    int childRows = rnd.Next(1, 100);
                    for (int j = 0; j < childRows; j++)
                    {
                        dt.Rows.Add(parentRow["series_cde"], parentRow["episode_Cde"]);
                      
                    }
                }
            }
          ds.EnforceConstraints = true;

            ultraGrid1.DataSource = ds;

       
        }

        private DataTable geneareTable(string tabelName, DataTable parentTable, string parentColumnId)
        {
            DataTable dt = parentTable.DataSet.Tables.Add(tabelName);
            dt.Columns.Add("series_cde", typeof(int));
            dt.Columns.Add("episode_Cde", typeof(int)).AutoIncrement = true;
            dt.Columns.Add("Row Type", typeof(string)).Expression = string.Format("'{0}'",tabelName);
            dt.Columns.Add("Some Text" , typeof(string)).DefaultValue = string.Format("Some test string for {0}", tabelName);
            parentTable.DataSet.Relations.Add(parentTable.Columns[parentColumnId], dt.Columns["series_cde"]);

            return dt;
        }

        private DataTable geneareEpsTable(string tabelName, DataTable parentTable, string parentColumnId)
        {
            DataTable dt = parentTable.DataSet.Tables.Add(tabelName);
            dt.Columns.Add("series_cde", typeof(int));
            dt.Columns.Add("episode_Cde", typeof(int));
            dt.Columns.Add("eid", typeof(int)).AutoIncrement = true;            
            dt.Columns.Add("Type", typeof(string)).Expression = string.Format("'{0}'", tabelName);
            dt.Columns.Add("Some Text", typeof(string)).DefaultValue = string.Format("Some test string for {0}", tabelName);

            DataColumn[] parentColumns = new DataColumn[] { parentTable.Columns["series_cde"], parentTable.Columns["episode_Cde"] };
            DataColumn[] childColumns = new DataColumn[] {
	dt.Columns["series_cde"],
	dt.Columns["episode_Cde"]
};
            parentTable.DataSet.Relations.Add(parentColumns, childColumns);

          
            return dt;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {

            e.Layout.Override.AllowColSizing = AllowColSizing.Free;
            e.Layout.Bands["Table1"].ColHeadersVisible = false;
            e.Layout.Bands["Table1"].Columns[0].Hidden = true;
            e.Layout.Bands["Table1"].Columns[1].Width = 500;
            e.Layout.Bands["Table1"].Columns[1].CellActivation = Activation.ActivateOnly;
            e.Layout.Bands["Table1"].Override.RowSelectors = Infragistics.Win.DefaultableBoolean.False;
            e.Layout.Bands["Table1"].Override.BorderStyleCell = Infragistics.Win.UIElementBorderStyle.None;
            e.Layout.Bands["Table1"].Override.BorderStyleRow = Infragistics.Win.UIElementBorderStyle.None;

            e.Layout.Bands["Table2"].ColHeadersVisible = false;
            e.Layout.Bands["Table2"].Columns[0].Hidden = true;
            e.Layout.Bands["Table2"].Columns[1].Hidden = true;
            e.Layout.Bands["Table2"].Columns[2].Width = 500;
            e.Layout.Bands["Table2"].Columns[1].CellActivation = Activation.ActivateOnly;
            e.Layout.Bands["Table2"].Override.RowSelectors = Infragistics.Win.DefaultableBoolean.False;
            e.Layout.Bands["Table2"].Override.BorderStyleCell = Infragistics.Win.UIElementBorderStyle.None;
            e.Layout.Bands["Table2"].Override.BorderStyleRow = Infragistics.Win.UIElementBorderStyle.None;
            foreach (UltraGridBand band in e.Layout.Bands)
            {
                if (band.Index > 1 && band.Index < 6)
                    band.SortedColumns.Add("Row Type", false, true);

                if ( band.Index > 7)
                    band.SortedColumns.Add("Type", false, true);
            }
        }

        private void ultraGrid1_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            if(e.Row.Band.Key == "Table1")
            {
                StringBuilder label = new StringBuilder();
                label.Append("Row Type:");
                DataRow row = ((DataRowView)e.Row.ListObject).Row;
                 foreach (DataRelation rel in row.Table.ChildRelations)
                 {
                    int childRowsCount =  row.GetChildRows(rel).Count();
                    string childTableName = rel.ChildTable.TableName;
                    label.AppendFormat("{0} ({1} items), ", childTableName, childRowsCount);
                }

                 e.Row.Cells[1].Value = label.ToString();

                 Debug.WriteLine(label.ToString());
            }

            if (e.Row.Band.Key == "Table2")
            {
                StringBuilder label = new StringBuilder();
                label.Append("Row Type:");
                DataRow row = ((DataRowView)e.Row.ListObject).Row;
                foreach (DataRelation rel in row.Table.ChildRelations)
                {
                    int childRowsCount = row.GetChildRows(rel).Count();
                    string childTableName = rel.ChildTable.TableName;
                    label.AppendFormat("{0} ({1} items), ", childTableName, childRowsCount);
                }

                e.Row.Cells[2].Value = label.ToString();

                Debug.WriteLine(label.ToString());
            }
        }

        
    }
}
